'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'This program solves a DSGE model. Appling this program to your model, 
'you get a state space representation(in other words, a reduced form). 

'To apply the program, your model should be transformed as follows:

'A0*[k(t+1)   ] =B0*[k(t)]+C0*ep(t)
'     [Ey(t+1)]         [y(t)]
'ep(t)=D0*ep(t-1)+u(t)

'whereA0, B0, and C0 denotes the coefficients matrices,
'k(t) denotes a state variables vector, y(t) a jump variables vector, 
'ep(t) a structural shcoks vector. 
'u(t) is an i.i.d. shock vector.


'This program yields the following state space representation:
'k(t+1)=alpha1*k(t)+alpha2*ep(t) 
'y(t)    =beta1*k(t)+beta2*ep(t) 
'The Main outputs of this program are alpha 1, alpha 2, beta 1, and beta 2.
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/



'Procedure
'Step 1. Create the folder under the C drive(the programs run in C:DSGE)
'Step 2. Create coefficients matrices, A0, B0, C0, and D0 in the Eviews workfile.
'Step 3. Fill the number of jump, state, and exogenous variables in the following. 
scalar jump=
scalar state=
scalar exo=
'Step 4. Run this program(click "Run" botten of this program).


exec C:\DSGE\solve_dsge.prg
