'This program implements the Jordan decomposition and prodvide the sorted matrices, L and Q
' such that L=Q^-1*A*Q, where Q's columns are eigenvectors and the L's diagonal elements are the eigenvalues of A. 



!n = @columns(A)


'Schur decomposition by QR method
'In detail, see pp 330 in  Golub, G.H. and Van Loan, C.F.(1996, Matrix Computations, Johs Hopkins University Press, Baltimore and London)


matrix PP=@identity(!n)
matrix AA=A
for !i=1 to 1000

    exec C:\DSGE\QR.prg
    matrix QQ=Q
    matrix RR=R
    matrix AA=RR*QQ
    matrix PP=PP*QQ

next


  
vector eigen = @getmaindiagonal(AA)




matrix  l=AA

'Diagonalization
'In detail, seepp 368 in Golub, G.H. and Van Loan, C.F.(1996)

for !j=2 to !n
    for !i=1 to !j-1
     if @abs(AA(!i,!i))=@abs(AA(!i+1,!i+1)) then   
          string comm_eigen = "Your model has multiple roots (see 'eigen'). Please modify your model." 
          show comm_eigen
          stop
     else
     endif
        scalar z=-AA(!i,!j)/(AA(!i,!i)-AA(!j,!j))
        l(!i,!j)=0
        for !k=!j+1 to !n
            AA(!i, !k)=AA(!i, !k)-z*AA(!j,!k)
        next
        for !k=1 to !n
            PP(!k, !j)=PP(!k,!i)*z+PP(!k,!j)
        next
   next
next

if @norm(A-PP*l*@inverse(PP),2)<0.0001 then
   else
   string comm_jordan = "The program fails to diagonalize the matrix A(0)^(-1)*B(0)." 
   show comm_jordan 
   stop
 endif


'Sorting 

matrix l_sort=l
matrix Q_sort=PP


for !j=1 to !n
     for !i=1 to !n-1

     if @abs(l_sort(!i,!i))<@abs(l_sort(!i+1,!i+1)) then

        else
        
        !d1=l_sort(!i,!i)
        !d2=l_sort(!i+1,!i+1)
        l_sort(!i+1,!i+1)=!d1 
        l_sort(!i,!i)=!d2
        matrix sort=@identity(!n)     
        sort(!i,!i)=0
        sort(!i+1,!i+1)=0
        sort(!i,!i+1)=1
        sort(!i+1,!i)=1
        Q_sort=Q_sort*sort
       endif
   next
next

matrix P=@inverse(Q_sort)

if @norm(A-Q_sort*l_sort*@inverse(Q_sort),2)<0.0001 then
   else
   string comm_jordan = "The program fails tosortinng the eigenvalues." 
   show comm_jordan 
   stop
 endif
